<template>
  <page
    class="flex-grow-1"
    id="find_card"
    title="Cartões"
  >
    <v-list two-line="two-line">
      <v-list-item v-if="!cards || cards.length === 0">
        <v-list-item-content>
          <v-list-item-title>No results found!</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item
        v-else
        v-for="card in cards"
        :key="card.id"
      >
        <v-list-item-content>
          <v-list-item-title>{{card.code}}</v-list-item-title>
          <v-list-item-subtitle>{{card.person && card.person.fullname}}</v-list-item-subtitle>
        </v-list-item-content>
        <v-list-item-action>
          <v-btn
            icon="icon"
            @click="$router.push({ name: 'card', params: { id: card.id } })"
          >
            <v-icon>mdi-information</v-icon>
          </v-btn>
        </v-list-item-action>
      </v-list-item>
    </v-list>
  </page>
</template>

<script lang="ts">
import Vue from 'vue'

import Page from '@/components/Page.vue'

import listCardsQuery from '@/gql/CardList.gql'
import listCardsSubscription from '@/gql/CardListSubscription.gql'

export default Vue.extend({
  name: 'CardsPage',
  components: { Page },
  apollo: {
    cards: {
      query: listCardsQuery,
      subscribeToMore: {
        document: listCardsSubscription,
        updateQuery: (previousResult, { subscriptionData }) => {
          return subscriptionData.data
        }
      }
    }
  }
})
</script>
